<template>
	<f7-page 
        name="login"
		no-toolbar 
		no-navbar
		no-swipeback
        login-screen>
		<f7-block class="display-flex align-items-center justify-content-center" style="height:calc(100% - 50px);">
			<div class="text-align-center">
                <img :src="require('../assets/logo.png')" width="150">                
                <div v-if="authStatus == 'login'">
                    <p class="padding-medium">Enter your phone number to login. We'll send you an OTP to your registered mobile phone.</p>
                    <f7-list form class="no-hairlines-between">
                        <f7-list-input
                            class="text-normal text-align-center"
                            ref="identity"
                            label=""
							type="number"
                            placeholder="Mobile phone number"
                            :value="loginForm.identity"
                            @input="loginForm.identity = $event.target.value">
                        </f7-list-input>				
                    </f7-list>
                    <f7-block class="margin-small-top margin-medium-left margin-medium-right">
                        <f7-button @click="doLogin" fill large>Log me in</f7-button>
                    </f7-block>
                </div>
                <div v-else-if="authStatus == 'verify'">
                    <p class="padding-medium">Enter 6 digits OTP sent to your mobile phone.</p>
                    <f7-list no-hairlines no-hairlines-between form>
                        <f7-list-input
                            name="passkey"
                            ref="passkey"
                            label=""
                            placeholder="••••••"
                            :value="verifyForm.passkey"
                            @input="verifyForm.passkey = $event.target.value"
                            minlength="1"
                            maxlength="6">
                            <span slot="content-end" style="width:80px;">
                                <strong>
                                    <countdown ref="countdown" v-if="counting" :time="300000" :transform="transform" @end="handleCountdownEnd">
                                        <template slot-scope="props">{{ props.minutes }} : {{ props.seconds }}</template>
                                    </countdown>
                                    <span v-else>00:00</span>
                                </strong>
                            </span>
                        </f7-list-input>				
                    </f7-list>
                    <f7-block class="margin-small-top no-padding">
                        <f7-row>
                            <f7-col>
                                <f7-button @click="doVerify" fill large>Verify</f7-button>
                            </f7-col>
                            <f7-col>
                                <f7-link class="display-inline-block margin-small-top" @click="doReverify" :disabled="counting">Resend SMS OTP</f7-link>
                            </f7-col>
                        </f7-row>
                    </f7-block>
                </div>
            </div>
			<f7-link popup-open=".scanner-popup" class="scan"><f7-icon material="center_focus_strong"></f7-icon> Scan Code</f7-link>
			<f7-popup @popup:opened="scanPopupOpened($event)" @popup:closed="scanPopupClosed($event)" class="scanner-popup">
                <f7-page class="scan-page">
					<f7-navbar>
						<f7-nav-right>
							<f7-link popup-close><f7-icon material="close"></f7-icon></f7-link>
						</f7-nav-right>
					</f7-navbar>
					<h3>Scan Code</h3>
					<f7-icon class="target" material="crop_free" size="450" color="white"></f7-icon>
					<f7-link @click="handleFlash" class="flash"><f7-icon :material="`flash_${scannerStatus != null && scannerStatus.lightEnabled ? 'on' : 'off'}`"></f7-icon></f7-link>
					<f7-link @click="handleStartScan" class="start"><f7-icon material="center_focus_strong" :color="scannerStatus != null && scannerStatus.previewing ? 'red' : 'white'"></f7-icon></f7-link>
					<f7-link @click="handleCamera" class="flip">
						<f7-icon v-if="scannerStatus != null && scannerStatus.currentCamera == 0" material="switch_camera"></f7-icon>
						<f7-icon v-else material="camera_front"></f7-icon>
					</f7-link>
                </f7-page>
            </f7-popup>
			<f7-sheet
				class="document-sheet"
				style="height:auto; --f7-sheet-bg-color: #fff;"
				swipe-to-close
				swipe-to-step
				backdrop
				v-if="document != null">

				<div class="sheet-modal-swipe-step">
					<f7-row style="padding:16px;">
						<f7-col width="30">
							<qrcode :value="document.tracking_number" :options="{ width: 100 }"></qrcode>
						</f7-col>
						<f7-col width="70">
							<small class="display-block margin-small-top">Tracking Number</small>
							<h4 class="no-margin-top margin-small-bottom">{{ document.tracking_number }}</h4>
							<small>Title</small>
							<h4 class="no-margin-top">{{ document.title }}</h4>
						</f7-col>
					</f7-row>
					<div class="padding-horizontal padding-bottom">
					<div class="margin-top text-align-center">Swipe up for more details</div>
					</div>
				</div>

				<f7-block strong inset class="no-margin-top no-margin-bottom">
					<h4>Status</h4>
					<ul class="timeline">
						<li 
							class="timeline-item"
							v-for="(status, index) in document.statuses"
							:key="index"
							>
							<div class="timeline-item-tail"></div>
							<div class="timeline-item-node timeline-item-node-normal"></div>
							<div class="timeline-item-wrapper">
								<div class="timeline-timestamp">{{ dateFormat(status.created) }}</div>
								<div class="timeline-item-content">
									<h4 class="no-margin-bottom">{{ status.status.name }} <f7-icon v-if="status.notified" material="notifications_none"></f7-icon> </h4>
									<small class="display-block">Updated By: {{ status.author.fullname }}</small>
									<span class="display-block margin-small-top">{{ status.note }}</span>
								</div>
							</div>
						</li>
					</ul>
				</f7-block>

			</f7-sheet>
		</f7-block>
	</f7-page>
</template>

<script>
import { mapGetters } from 'vuex';
import { parseError, convertAmpersand, validEmail, validPhone, dateFormat } from '../js/utils'
export default {
	name: 'LoginPage',
	data() {
		return {
			loginForm: {
				identity: ''
			},
			verifyForm: {
				passkey: ''
			},
			counting: false,
			scannerStatus: null
		};
	},
	computed: {
		...mapGetters('auth', [
			'authStatus',
			'verificationCode'
		]),
		...mapGetters('document', ['document'])
	},
	methods: {
		dateFormat,
        convertAmpersand,
		transform(props) {
			Object.entries(props).forEach(([key, value]) => {
				const digits = value < 10 ? `0${value}` : value;
				props[key] = `${digits}`;
			});
			return props;
		},
		handleCountdownEnd(){
			this.counting = false;
		},
		setLogin(){
			const self = this;

			self.$store.dispatch('auth/setLogin');
		},
		doLogin() {
			const self = this;
			const app = self.$f7;
			const router = self.$f7router;

			let identity = self.loginForm.identity;

			if(identity.trim().length == 0){
				app.dialog.alert('Mobile phone number is required', 'Doctrin');
				return false;
			}else if(validEmail(identity) == false && validPhone(identity) == false){
				app.dialog.alert('Invalid mobile phone number', 'Doctrin');
				return false;
			}

			app.preloader.show('white');
			
			self.$store.dispatch('auth/doLogin', {
				identity: identity,
				access: 'mobile'
			}).then((response) => {
				app.preloader.hide();

				if('errors' in response){
					const error = parseError(response.errors)
					app.dialog.alert(error.messages, 'Doctrin');
					return false;
				}else{
					self.verifyForm.passkey = '';
					self.counting = true;
				}
			});
		},
		doVerify(){
			const self = this;
			const app = self.$f7;
			const $$ = self.$$;
			const router = self.$f7router;

			let passkey = self.verifyForm.passkey;

			if(passkey.trim().length == 0){
				app.dialog.alert('6 Digits OTP is required');
				return false;
			}

			app.preloader.show('white');

			self.$store.dispatch('auth/doVerify', {
				passkey: passkey,
				code: self.verificationCode,
				exclude: 'role.permissions'
			}).then((response) => {	
				app.preloader.hide();		
				if('errors' in response){
					const error = parseError(response.errors);
					app.dialog.alert(error.messages);
					return false;
				}else{
					self.loginForm.indentity = '';
					self.counting = false;

					const homeTab = $$('#view-home');

					homeTab.trigger('tab:show');
					app.emit('tabShow', homeTab[0]);
					// app.tab.show('#view-home', true);				
				}
			});
		},
		doReverify(){
			const self = this;
			const app = self.$f7;
			const router = self.$f7router;

			app.preloader.show('white');

			self.$store.dispatch('auth/doReverify', {
				code: self.verificationCode
			}).then((response) => {		
				app.preloader.hide();	
				if('errors' in response){
					const error = parseError(response.errors);
					app.preloader.hide();
					app.dialog.alert(error.messages);
					return false;
				}
			});
		},
		handleCamera(){
			const self = this;
			const app = self.$f7;

			QRScanner.getStatus(function(status){
				if(status.canChangeCamera){
					if(status.lightEnabled){
						QRScanner.disableLight(function(err, status){
							if(err){
								app.dialog.alert(err._message, 'Doctrin');
							}
							self.scannerStatus = status;
						});
					}else{
						QRScanner.enableLight(function(err, status){
							if(err){
								app.dialog.alert(err._message, 'Doctrin');
							}
							self.scannerStatus = status;
						});
					}
				}				
			});
		},
		handleFlash(){
			const self = this;
			const app = self.$f7;

			QRScanner.getStatus(function(status){
				if(status.lightEnabled){
					QRScanner.disableLight(function(err, status){
						if(err){
							app.dialog.alert(err._message, 'Doctrin');
						}
						self.scannerStatus = status;
					});
				}else{
					QRScanner.enableLight(function(err, status){
						if(err){
							app.dialog.alert(err._message, 'Doctrin');
						}
						self.scannerStatus = status;
					});
				}
			});
		},
		handleStartScan(){
			const self = this;
			const app = self.$f7;

			QRScanner.getStatus(function(status){
				if(status.previewing){
					QRScanner.pausePreview(function(status){
						self.scannerStatus = status;
					});
				}else{
					QRScanner.scan(function(err, contents){
						if(err){
							app.dialog.alert(err._message, 'Doctrin');
						}else{
							self.doTracking(contents);
						}
					});
				}
			});			
		},
		doTracking(trackingNumber){
			const self = this;
			const app = self.$f7;
			const $$ = self.$$;

			app.preloader.show('blue');

			self.$store.dispatch('document/trackDocument', {
				tracking_number: trackingNumber
			}).then(()=>{
				app.preloader.hide();

				//trigger sheet modal
				if(!self.sheet){
					self.sheet = app.sheet.create({
						el: '.document-sheet',
						swipeToClose: false,
						swipeToStep: true,
						backdrop: true,
						closeByBackdropClick: false
					});								
				}

				if ($$('.document-sheet.modal-in').length > 0) $sheet.close('.document-sheet');
				
				self.sheet.open();
			});
		},
		scanPopupOpened(){
			const self = this;
			const app = self.$f7;
			const $$ = self.$$;

			$$('.safe-areas').hide();

			QRScanner.getStatus(function(status){
				if(!status.authorized && status.canOpenSettings){
					app.dialog.confirm("Would you like to enable QR code scanning? You can allow camera access in your settings.", "Doctrin", function(){
						QRScanner.openSettings();
					});
				}else{
					QRScanner.show(function(status){
						self.scannerStatus = status;
					});
				}
			});
			
		},
		scanPopupClosed(){
			const self = this;
			const app = self.$f7;
			const $$ = self.$$;

			$$('.safe-areas').show();

			QRScanner.destroy(function(status){
				self.scannerStatus = null;
			});
		}
	}
};
</script>

<style lang="scss" scoped>
	.scan{
		position: absolute;
		top: 0;
		right: 24px;

		.icon{
			margin-right: 5px;
		}
	}

	.scanner-popup{
		background: none;
		.page{
			background: none;
			.navbar{
				background: none;
				top: 20px;

				.right{
					margin-right: 10px;
				}

				a{
					color: #fff;
				}
			}
			.navbar:after{
				content: none;
			}
			.page-content{
				h3{
					text-align: center;
					margin-top:30px;
					color: #fff;
				}

				a{
					position: absolute;
					.icon{
						font-size: 32px;
						color: #fff;
					}
				}

				.target{
					position: absolute;
					top: 50%;
					left: 50%;
					transform: translate(-50%, -50%);
					color: #fff;
				}

				.flash{
					bottom: 50px;
					left: 50px;
				}

				.start{
					bottom: 50px;
					left: 50%;
					transform: translate(-50%);
					.icon{
						font-size: 40px;	
					}
				}

				.flip{
					bottom: 50px;
					right: 50px;
				}
			}
		}
	}
</style>